#include <ESP8266WiFi.h>
#include <spiEspDirect.h>

void SpiEspDirect::delayESP8266(unsigned long ulMilliseconds){
  unsigned long ulPreviousMillis = millis();

  do{
    yield();
  }while(millis() - ulPreviousMillis <= ulMilliseconds);
}

void SpiEspDirect::vHSPIinit(){
  spiESP->spi_init(HSPI);
  spiESP->spi_mode(HSPI,1,0);
  //spi_clock(HSPI,10,32);
  delayESP8266(10);
  
  //Serial.println("Master Initialized");
}

byte SpiEspDirect::bySpiWr(byte addr,byte value){
    byte result;
  
    digitalWrite(SS, LOW);          // Select LoRa module
    result = spiESP->spi_tx8(HSPI,addr | 0x80);
    //Serial.println(String(result) +" <- result = spi_tx8(HSPI,"+String(addr)+" | 0x80);");
    delayESP8266(20);
    result = spiESP->spi_tx8(HSPI, value);
    //Serial.println(String(result) +" <- result = spi_tx8(HSPI, "+String(value)+");");
    delayESP8266(20);
    digitalWrite(SS, HIGH);         // Deselect LoRa module

    return result;
}

byte SpiEspDirect::bySpiRd(byte addr){
    byte result;

    digitalWrite(SS, LOW);          // Select LoRa module
    result = spiESP->spi_tx8(HSPI,addr /*| 0x80*/);
    delayESP8266(20);
    result = spiESP->spi_rx8(HSPI);
    //Serial.println("rx=" + String(result) +" <- spi_rx8(HSPI);");
    delayESP8266(20);
    digitalWrite(SS, HIGH);         // Deselect LoRa module

    return result;
}

byte SpiEspDirect::SPIwriteRegister(byte addr,byte value){
	return bySpiWr( addr, value);
}

byte SpiEspDirect::SPIreadRegister(byte addr){
	return bySpiRd( addr );
}

void SpiEspDirect::SPIwriteBurst(unsigned char addr, unsigned char *ptr, unsigned char len){
  byte i,result;

    digitalWrite(SS, LOW);          // Select LoRa module

    //delayESP8266(20);
    result = spiESP->spi_tx8(HSPI,addr | 0x80);
    //Serial.print(String(result) +" <- result = spi_tx8(HSPI,"+String(addr)+" | 0x80){");
    delayESP8266(20);

    for (i=0; i <= len; i++){
      result = spiESP->spi_tx8(HSPI, *ptr);
      //Serial.println(String(result) +" <- result = spi_tx8(HSPI, "+String(*ptr)+");");
      //Serial.print(*ptr, HEX);
      delayESP8266(20);
      ptr++;
    }
    //Serial.print("}\n");
    digitalWrite(SS, HIGH);         // Deselect LoRa module
}

void SpiEspDirect::SPIreadBurst(unsigned char addr, unsigned char *ptr, unsigned char len){
  byte i,result;

    digitalWrite(SS, LOW);          // Select LoRa module

    result = spiESP->spi_tx8(HSPI,addr /*| 0x80*/);
    //Serial.print(String(result) +" <- result = spi_tx8(HSPI,  "+String(addr)+"){");
    delayESP8266(20);

    for (i=0; i <= len; i++){
      *ptr = spiESP->spi_rx8(HSPI);
      //Serial.print(*ptr, HEX);
      //Serial.println("rx=" + String(result) +" <- spi_rx8(HSPI);");
      delayESP8266(20);
      ptr++;
    }
    //Serial.print("}\n");
    digitalWrite(SS, HIGH);         // Deselect LoRa module
}
