#!/usr/bin/python
# -*- coding: utf-8 -*-

"""
freqMng.py
www.binefa.cat/blog
20160616
"""

import sys
from PyQt4 import Qt, QtGui, QtCore
from ui_freqMng import Ui_freqMangForm
import serial
from time import sleep

class FreqMangForm(QtGui.QWidget, Ui_freqMangForm):
	def __init__(self, parent=None, f=QtCore.Qt.WindowFlags()):
		QtGui.QWidget.__init__(self, parent, f)
		self.setupUi(self)
		self.connect(self.comboBox, Qt.SIGNAL("currentIndexChanged(QString)"), self.vSelectedFreqCB)
		self.connect(self.lineEditCustomFreq, Qt.SIGNAL("textChanged(QString)"), self.vSelectedFreqLE)
		self.connect(self.radioButtonSuggFreq, Qt.SIGNAL("toggled(bool)"), self.funcSetSuggFreq)
		self.connect(self.radioButtonCustomFreq, Qt.SIGNAL("toggled(bool)"), self.funcSetCustomFreq)
		self.fillComboBox()
		self.connect(self.pushButtonSetFreq, Qt.SIGNAL("clicked()"),self.funcReturnDlg)
		self.connect(self.pushButtonReadFreq,Qt.SIGNAL("clicked()"),self.funcReadFreq)
		
	def funcReturnDlg(self):
		self.emit(Qt.SIGNAL('returnFreqHexData'))
		
	def funcReadFreq(self):
		self.emit(Qt.SIGNAL('readFreq'))
		
	def fillComboBox(self):
		freqList = ["869.400"]
		i = 1
		while i < 11:
			newFreqListElement = "%.3f" % (float(freqList[i-1]) + 0.025)
			freqList .extend([newFreqListElement])
			i += 1
		self.comboBox.clear()
		self.comboBox.addItems(freqList)
		self.comboBox.setCurrentIndex(5)
		
	def vSelectedFreqLE(self, strFreq):
		if self.radioButtonCustomFreq.isChecked():
			self.byCalcRegisters(strFreq)
			fFreq = float(self.lineEditCustomFreq.text())
			if fFreq < 400 or fFreq > 999:
				self.pushButtonSetFreq.setEnabled(False)
			else:
				self.pushButtonSetFreq.setEnabled(True)				

	def vSelectedFreqCB(self, strFreq):
		if self.radioButtonSuggFreq.isChecked():
			self.lineEditCustomFreq.setText(strFreq)
			self.byCalcRegisters(strFreq)
			
	def funcSetSuggFreq(self,b):
		if b:
			self.lineEditCustomFreq.setText(self.comboBox.itemText(self.comboBox.currentIndex()))
			self.byCalcRegisters(self.comboBox.itemText(self.comboBox.currentIndex()))
			self.pushButtonSetFreq.setEnabled(True)	

	def funcSetCustomFreq(self,b):
		if b:
			self.byCalcRegisters(self.lineEditCustomFreq.text())
			fFreq = float(self.lineEditCustomFreq.text())
			if fFreq < 400 or fFreq > 999:
				self.pushButtonSetFreq.setEnabled(False)
			else:
				self.pushButtonSetFreq.setEnabled(True)				

	def byCalcRegisters(self, strFreq):
		num = int(round((float(strFreq)*1000000) / 61.035))
		#print "%d --> 0x%6X" % (num,num)
		self.byMsb = num >> 16
		self.labelRegFrMsb.setText("%2X" % self.byMsb)
		self.byMid = (num >> 8) & 0xFF
		self.labelRegFrMid.setText("%2X" % self.byMid)
		self.byLsb = num & 0xFF
		self.labelRegFrLsb.setText("%2X" % self.byLsb)

class FreqMangDlg(QtGui.QDialog):
    returnFreqHexData = Qt.SIGNAL('returnFreqHexData(float,int,int,int)')
    readFreq = Qt.SIGNAL('readFreq(int)')
	
    def __init__(self, parent = None):
        super(FreqMangDlg, self).__init__(parent)

        layout = QtGui.QVBoxLayout(self)
        self.fmf = FreqMangForm()
        self.connect(self.fmf, Qt.SIGNAL('returnFreqHexData'), self.returnFreq)
        self.connect(self.fmf, Qt.SIGNAL('readFreq'),  self.funcReadFreq)
        layout.addWidget(self.fmf)

    def returnFreq(self):
		#print "Freq: %.3fMHz --> %2X %2X %2X"%(float(self.fmf.lineEditCustomFreq.text()), self.fmf.byMsb,self.fmf.byMid,self.fmf.byLsb )
		self.save()
		#self.accept()
		self.close()
		
    def funcReadFreq(self):
		self.fmf.byMsb = self.fmf.byMid = self.fmf.byLsb = 0x00
		self.fmf.lineEditCustomFreq.setText("0")
		self.save()
		self.close()
		#print "funcReadFreq"

    def save(self):
		return float(self.fmf.lineEditCustomFreq.text()), self.fmf.byMsb,self.fmf.byMid,self.fmf.byLsb

if __name__ == '__main__':
	app = QtGui.QApplication(sys.argv)
	dlg = FreqMangDlg()
	#dlg.show()
	dlg.exec_()
	if dlg.result() == 0:
		fFreq,byMSB,byMid,byLSB = dlg.save()
		print "Freq: %.3fMHz --> %2X %2X %2X"%(fFreq,byMSB,byMid,byLSB) 
	sys.exit(0)

	#sys.exit(app.exec_())
